AppTitle("Farbdetektiv")
Global wdth=600
Graphics3D(wdth,wdth,32,2)
SetBuffer(BackBuffer())
Global timer=CreateTimer(60)
SeedRnd(MilliSecs())

Global cam=CreateCamera()
Global fl
HidePointer()
Global mx#,my#,mh

If(FileType("highscore.txt")<>1) Then
	fl=WriteFile("highscore.txt")
	WriteLine(fl,"Max: Level 10")
	WriteLine(fl,"Claudia: Level 9")
	WriteLine(fl,"Johann: Level 8")
	WriteLine(fl,"Sophie: Level 7")
	WriteLine(fl,"Olaf: Level 6")
	WriteLine(fl,"Sarah: Level 5")
	WriteLine(fl,"Frank: Level 4")
	WriteLine(fl,"Clara: Level 3")
	WriteLine(fl,"Thorsten: Level 2")
	WriteLine(fl,"Anna: Level 1")
	CloseFile(fl)
EndIf

Global menu$="main",name$
Global init,targetR,targetG,targetB,tolerance,level,cLeft,countdown
Dim winner$(9)

Global back=LoadSprite("img/back.jpg")
ScaleSprite(back,7,7)
PositionEntity(back,0,0,3)
Global backAngle#=0
Global backZoom#=1

Global logo=LoadSprite("img/logo.jpg",3)
ScaleSprite(logo,2.5,0.45)
PositionEntity(logo,0,2,3)

Global play=LoadSprite("img/play.jpg",4)
ScaleSprite(play,1.5,0.4)
PositionEntity(play,0,0.5,3)
EntityPickMode(play,3)
EntityBox(play,-1.5,0,3,3,0.8,1)

Global hs=LoadSprite("img/highscore.jpg",4)
EntityPickMode(hs,3)
ScaleSprite(hs,2,0.4)

Global quit=LoadSprite("img/quit.jpg",4)
ScaleSprite(quit,2,0.4)
PositionEntity(quit,0,-2,3)
EntityPickMode(quit,3)

Global enterName=LoadSprite("img/name.jpg",4)
ScaleSprite(enterName,2,0.4)
PositionEntity(enterName,0,2,3)
HideEntity(enterName)

Global pipette=LoadImage("img/pipette.png")
MaskImage(pipette,255,255,255)

Global hsFont=LoadFont("Courier",32,1)
Global gameFont=LoadFont("Courier",19,1)

Repeat
	Cls()
	WaitTimer(timer)
	mx#=MouseX()
	my#=MouseY()
	mh=MouseHit(1)
	If(menu<>"game") Then
		Local colorMode#=MilliSecs() Mod 15000
		If(colorMode<3000) Then
			CameraClsColor(cam,colorMode/3000*128,0,0)
		ElseIf(colorMode<6000) Then
			CameraClsColor(cam,128-((colorMode-3000)/3000*128),(colorMode-3000)/3000*128,0)
		ElseIf(colorMode<9000) Then
			CameraClsColor(cam,0,128,(colorMode-6000)/3000*128)
		ElseIf(colorMode<12000) Then
			CameraClsColor(cam,0,128-((colorMode-9000)/3000*128),128)
		Else
			CameraClsColor(cam,0,0,128-((colorMode-12000)/3000*128))
		EndIf
		backAngle=(backAngle+0.1) Mod 360
		RotateSprite(back,backAngle)
		If(MilliSecs() Mod 15000 < 7500) Then
			backZoom=backZoom+0.0006
		Else
			backZoom=backZoom-0.0006
		EndIf
		CameraZoom(cam,backZoom)
	EndIf
	
	UpdateWorld()
	RenderWorld()
	
	Select menu$
		Case "main"
			init=1
			Show(1,1,1,1,1)
			PositionEntity(hs,0,-1,3)
			Local picked=CameraPick(cam,mx,my)
			
			If(mh) Then
				If(picked=play) Then FlushKeys():menu="game"
				If(picked=hs) Then menu="hs"
				If(picked=quit) Then End()
			EndIf
		Case "game"
			Show()
			If(KeyHit(1)) Then FlushKeys():menu="main":cLeft=5:init=1
			
			If(init) Then
				If(level=10) Then menu="enter name":Return
				GenerateBackground()
				If(cLeft=0) Then level=level+1:cLeft=5
				cLeft=cLeft-1
				countdown=MilliSecs()+40000-level*2000
				tolerance=33-level*3
				init=0
			EndIf
			ChangeColor()
			If(countdown<MilliSecs()) Then
				FlushKeys():DebugLog("check")
				menu="enter name"
			EndIf
		Case "enter name"
			Show(1,0,0,0,0,1)
			ShowEntity(enterName)
			SetFont(hsFont)
			Text(wdth/2,wdth/2,name,wdth/2)
			Local key=GetKey()
			If(key>=32 And key<=126 And Len(name)<14) Then name=name+Chr(key)
			If(key=8 And Len(name)>0) Then name=Left(name,Len(name)-1)
			If((key=13 Or mh) And Len(name)>0) Then menu="hs"
		Case "hs"
			Show(1,0,0,1,0,0)
			PositionEntity(hs,0,2.5,3)
			fl=ReadFile("highscore.txt")
			For i=0 To 9
				winner(i)=ReadLine(fl)
				If(10-level=i And name<>"") Then winner(i)=name+": Level "+level
			Next
			CloseFile(fl)
			fl=WriteFile("highscore.txt")
			For i=0 To 9
				WriteLine(fl,winner(i))
			Next
			CloseFile(fl)
			SetFont(hsFont)
			For i=0 To 9
				Text(wdth/2,i*45+130,winner(i),wdth/2)
			Next
			If(mh Or KeyHit(1)) Then FlushKeys():level=0:cLeft=0:menu="main"
	End Select
	DrawImage(pipette,mx-15,my-128+15)
	Flip(0)
Forever

Function GenerateBackground()
	Local coin=Rnd(1,6)
	Select coin
		Case 1:targetR=Rnd(0,255):targetG=Rnd(0,255):targetB=targetG
		Case 2:targetR=255: targetB=Rnd(0,255):targetG=targetB+Rnd(0,255-targetB)
		Case 3:targetG=255:targetB=Rnd(0,255):targetR=targetB+Rnd(0,255-targetB)
		Case 4:targetG=255:targetR=Rnd(0,255):targetB=targetR+Rnd(0,255-targetR)
		Case 5:targetB=255:targetR=Rnd(0,255):targetG=targetR+Rnd(0,255-targetR)
		Case 6:targetB=255:targetG=Rnd(0,255):targetR=targetG+Rnd(0,255-targetG)
	End Select
	CameraClsColor(cam,targetR,targetG,targetB)
End Function

Function ChangeColor()
	Local r#=my/600*255
	Local g#=my/600*255
	Local b#=my/600*255
	
	If(mx<=100) Then
		r=r+mx/100*255
	ElseIf(mx<=200) Then
		r=255
		g=g+(mx-100)/100*255
	ElseIf(mx<=300) Then
		r=r+(255-((mx-200)/100*255))
		g=255
	ElseIf(mx<=400) Then
		g=255
		b=b+(mx-300)/100*255
	ElseIf(mx<=500) Then
		g=g+(255-((mx-400)/100*255))
		b=255
	Else
		r=r+(mx-500)/100*255
		b=255
	EndIf
	If(r>255) Then r=255
	If(g>255) Then g=255
	If(b>255) Then b=255
	Color(r,g,b)
	Rect(wdth/2-250,wdth/2-120,500,300)
	SetFont(gameFont)
	Color(0,0,0)
	Rect(0,0,wdth,60)
	Color(255,255,255)
	Text(0,10,"Gesuchte Farbe: "+targetR+","+targetG+","+targetB)
	Text(0,30,"Aktuelle Farbe: "+Int(r)+","+Int(g)+","+Int(b))
	Text(450,10,"Level: "+level)
	Text(450,30,"Countdown: "+(countdown-MilliSecs())/1000)
	
	If(Abs(targetR-r)<tolerance And Abs(targetG-g)<tolerance And Abs(targetB-b)<tolerance) Then init=1
End Function

Function Show(b=0,l=0,p=0,h=0,q=0,n=0)
	If(b=0) Then HideEntity(back) Else ShowEntity(back)
	If(l=0) Then HideEntity(logo) Else ShowEntity(logo)
	If(p=0) Then HideEntity(play) Else ShowEntity(play)
	If(h=0) Then HideEntity(hs) Else ShowEntity(hs)
	If(q=0) Then HideEntity(quit) Else ShowEntity(quit)
	If(n=0) Then HideEntity(enterName) Else ShowEntity(enterName)
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D